diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index 5299c2583..11b27bd85 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -142,55 +142,52 @@ public abstract class OptionsPages {
         );
 
         VIDEO = register(new OptionsPage("gui.options.page.video.title", new ItemStack(Items.FLAG))
-                .withComponent(new OptionsCategory("gui.options.page.video.category.graphics")
+                .withComponent(new OptionsCategory("gui.options.page.video.category.display")
                     .withComponent(new BooleanOptionComponent(GameSettings.FULLSCREEN))
                     .withComponent(new BooleanOptionComponent(GameSettings.BORDERLESS_FULLSCREEN))
+                    .withComponent(new FloatOptionComponent(GameSettings.GAMMA))
+                    .withComponent(new BooleanOptionComponent(GameSettings.ENABLE_VSYNC))
+                    .withComponent(new FramerateOptionComponent(GameSettings.CUSTOM_FPS_LIMIT))
                     .withComponent(new ToggleableOptionComponent<>(GameSettings.RENDER_SCALE))
-                    .withComponent(new ToggleableOptionComponent<>(GameSettings.RENDER_DISTANCE))
-                    .withComponent(new BooleanOptionComponent(GameSettings.AMBIENT_OCCLUSION))
-                    .withComponent(new BooleanOptionComponent(GameSettings.CONNECTED_GLASS))
-                    .withComponent(new ToggleableOptionComponent<>(GameSettings.MIPMAP_LEVELS).applyOnRelease())
-                    .withComponent(new ToggleableOptionComponent<>(GameSettings.MIPMAP_TYPE).applyOnRelease())
                     .withComponent(new ToggleableOptionComponent<>(GameSettings.COLORBLINDNESS_FIX))
                 )
-                .withComponent(new OptionsCategory("gui.options.page.video.category.performance")
-                        .withComponent(new BooleanOptionComponent(GameSettings.ENABLE_VSYNC))
-                        .withComponent(new FramerateOptionComponent(GameSettings.CUSTOM_FPS_LIMIT))
-//                .withComponent(new BooleanOptionComponent(GameSettings.advancedOpenGL))
-                )
-                .withComponent(new OptionsCategory("gui.options.page.video.category.post_processing")
-                    .withComponent(new FloatOptionComponent(GameSettings.GAMMA))
-                    .withComponent(new FloatOptionComponent(GameSettings.COLOR_CORRECTION))
-                    .withComponent(new FloatOptionComponent(GameSettings.FXAA))
-                    .withComponent(new ToggleableOptionComponent<>(GameSettings.BLOOM))
-                    .withComponent(new BooleanOptionComponent(GameSettings.HEAT_HAZE))
-                )
                 .withComponent(new OptionsCategory("gui.options.page.video.category.visuals")
+                    .withComponent(new BooleanOptionComponent(GameSettings.AMBIENT_OCCLUSION))
                     .withComponent(new ToggleableOptionComponent<>(GameSettings.LIGHTMAP_STYLE))
                     .withComponent(new FloatOptionComponent(GameSettings.BRIGHTNESS))
-                    .withComponent(new BooleanOptionComponent(GameSettings.FOV_MODIFICATION))
-                    .withComponent(new BooleanOptionComponent(GameSettings.SCREEN_MOTION_EFFECTS))
+                    .withComponent(new BooleanOptionComponent(GameSettings.CONNECTED_GLASS))
                     .withComponent(new BooleanOptionComponent(GameSettings.FOG))
                     .withComponent(new BooleanOptionComponent(GameSettings.BIOME_WATER))
-                    .withComponent(new FloatOptionComponent(GameSettings.ENTITY_RENDER_DISTANCE, 0.1f, 3f))
-                    .withComponent(new BooleanOptionComponent(GameSettings.ENTITY_SHADOWS))
-                    .withComponent(new ToggleableOptionComponent<>(GameSettings.TEXT_OUTLINE_QUALITY))
                     .withComponent(new BooleanOptionComponent(GameSettings.CLOUDS))
-                    .withComponent(new ToggleableOptionComponent<>(GameSettings.CLOUD_QUALITY))
                     .withComponent(new FloatOptionComponent(GameSettings.CLOUD_HEIGHT, -0.5f, 1f))
-                    .withComponent(new ToggleableOptionComponent<>(GameSettings.LEAVES_QUALITY).applyOnRelease())
-                    .withComponent(new ToggleableOptionComponent<>(GameSettings.PARTICLES_QUALITY))
-                    .withComponent(new ToggleableOptionComponent<>(GameSettings.PARTICLES_CAP))
-                    .withComponent(new FloatOptionComponent(GameSettings.PARTICLE_RENDER_DISTANCE, 0.1f, 3f))
                     .withComponent(new BooleanOptionComponent(GameSettings.TREE_SHADOWS))
                     .withComponent(new BooleanOptionComponent(GameSettings.VIGNETTE))
                     .withComponent(new BooleanOptionComponent(GameSettings.ITEMS_3D))
                     .withComponent(new BooleanOptionComponent(GameSettings.AURORA))
                     .withComponent(new BooleanOptionComponent(GameSettings.SLIME_PARTICLES))
                     .withComponent(new FloatOptionComponent(GameSettings.BLOCK_OUTLINE_WIDTH))
+                )
+                .withComponent(new OptionsCategory("gui.options.page.video.category.post_processing")
+                    .withComponent(new FloatOptionComponent(GameSettings.COLOR_CORRECTION))
+                    .withComponent(new FloatOptionComponent(GameSettings.FXAA))
+                    .withComponent(new ToggleableOptionComponent<>(GameSettings.BLOOM))
+                    .withComponent(new BooleanOptionComponent(GameSettings.HEAT_HAZE))
+                )
+                .withComponent(new OptionsCategory("gui.options.page.video.category.performance")
+                    .withComponent(new ToggleableOptionComponent<>(GameSettings.RENDER_DISTANCE))
+                    .withComponent(new ToggleableOptionComponent<>(GameSettings.MIPMAP_LEVELS).applyOnRelease())
+                    .withComponent(new ToggleableOptionComponent<>(GameSettings.MIPMAP_TYPE).applyOnRelease())
                     .withComponent(new BooleanOptionComponent(GameSettings.TRANSPARENCY_DEPTH_CHECK))
                     .withComponent(new BooleanOptionComponent(GameSettings.FRUSTUM_CULLING))
                     .withComponent(new ToggleableOptionComponent<>(GameSettings.CHUNK_REBUILDS_PER_FRAME))
+                    .withComponent(new ToggleableOptionComponent<>(GameSettings.LEAVES_QUALITY).applyOnRelease())
+                    .withComponent(new ToggleableOptionComponent<>(GameSettings.PARTICLES_QUALITY))
+                    .withComponent(new ToggleableOptionComponent<>(GameSettings.PARTICLES_CAP))
+                    .withComponent(new FloatOptionComponent(GameSettings.PARTICLE_RENDER_DISTANCE, 0.1f, 3f))
+                    .withComponent(new FloatOptionComponent(GameSettings.ENTITY_RENDER_DISTANCE, 0.1f, 3f))
+                    .withComponent(new BooleanOptionComponent(GameSettings.ENTITY_SHADOWS))
+                    .withComponent(new ToggleableOptionComponent<>(GameSettings.CLOUD_QUALITY))
+                    .withComponent(new ToggleableOptionComponent<>(GameSettings.TEXT_OUTLINE_QUALITY))
                 )
         );
 
diff --git a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
index 8b6e38fc4..bc37df58f 100644
--- a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
+++ b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
@@ -52,6 +52,7 @@ import net.minecraft.core.net.handler.PacketHandler;
 import net.minecraft.core.net.packet.*;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.player.gamemode.Gamemodes;
+import net.minecraft.core.player.inventory.container.ContainerInventory;
 import net.minecraft.core.player.inventory.menu.MenuAbstract;
 import net.minecraft.core.player.inventory.container.ContainerSimple;
 import net.minecraft.core.sound.SoundTypes;
@@ -68,6 +69,7 @@ import net.minecraft.core.world.data.SynchedEntityData;
 import net.minecraft.core.world.pos.ChunkPos;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.save.LevelData;
+import net.minecraft.core.world.save.LevelStorageDummy;
 import net.minecraft.core.world.saveddata.SavedDataStorage;
 import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.weather.Weathers;
@@ -100,7 +102,7 @@ public class PacketHandlerClient extends PacketHandler {
         throws IOException {
         this.disconnected = false;
         this.started = false;
-        this.savedDataStorage = new SavedDataStorage(null);
+        this.savedDataStorage = new SavedDataStorage(new LevelStorageDummy());
         this.rand = new Random();
         this.mc = minecraft;
         Socket socket = new Socket(InetAddress.getByName(host), port);
@@ -842,7 +844,7 @@ public class PacketHandlerClient extends PacketHandler {
     public void handleContainerSetSlot(@NotNull PacketContainerSetSlot packetContainerSetSlot) {
         if (packetContainerSetSlot.windowId == -1) {
             this.mc.thePlayer.inventory.setHeldItemStack(packetContainerSetSlot.myItemStack);
-        } else if (packetContainerSetSlot.windowId == 0 && packetContainerSetSlot.itemSlot >= 36 && packetContainerSetSlot.itemSlot < 45) {
+        } else if (packetContainerSetSlot.windowId == 0 && packetContainerSetSlot.itemSlot >= ContainerInventory.MAIN_INVENTORY_SIZE && packetContainerSetSlot.itemSlot < ContainerInventory.MAIN_INVENTORY_SIZE + ContainerInventory.HOTBAR_SIZE) {
             ItemStack itemstack = this.mc.thePlayer.inventoryMenu.getSlot(packetContainerSetSlot.itemSlot).getItemStack();
             if (packetContainerSetSlot.myItemStack != null && (itemstack == null || itemstack.stackSize < packetContainerSetSlot.myItemStack.stackSize)) {
                 packetContainerSetSlot.myItemStack.animationsToGo = 5;
diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 66a3c52f8..07e442446 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -50,7 +50,7 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.BoundingVolume;
 import net.minecraft.core.util.phys.HitResult;
-import net.minecraft.core.world.AuroraProvider;
+import net.minecraft.client.world.AuroraProvider;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.pos.ChunkPos;
 import net.minecraft.core.world.pos.TilePos;
@@ -85,6 +85,8 @@ public class RenderGlobal
 
     public static final int RENDER_CHUNK_SIZE = 16;
 
+    private static final @NotNull AuroraProvider AURORA_PROVIDER = new AuroraProvider();
+
     public List<TileEntity> renderableTileEntities = new ObjectArrayList<>();
     private WorldClient world;
     private final TextureManager textureManager;
@@ -213,20 +215,20 @@ public class RenderGlobal
         return tessellator.record(GL41.glGenVertexArrays(), GL41.glGenBuffers());
     }
 
-    public void setWorld(final WorldClient world) {
+    public void setWorld(final @NotNull WorldClient world) {
         if (this.world != null) {
             this.world.removeListener(this);
         }
+
         this.xOld = -9999D;
         this.yOld = -9999D;
         this.zOld = -9999D;
         this.world = world;
         this.auroraBrightness = 0.0f;
         this.targetAuroraBrightness = Float.NaN;
-        if (world != null) {
-            world.addListener(this);
-            allChanged();
-        }
+        world.addListener(this);
+        AURORA_PROVIDER.init(world);
+        this.allChanged();
     }
 
     public void allChanged() {
@@ -311,7 +313,6 @@ public class RenderGlobal
 
         // Draw pieces
         double time = this.world.getWorldTime();
-        AuroraProvider aurora = this.world.auroraProvider;
 
         double radius = 512;
         long worldTime = this.world.getWorldTime();
@@ -329,8 +330,8 @@ public class RenderGlobal
                 distanceSqPercentage = 1f - distanceSqPercentage;
 
                 if (0.3f * distanceSqPercentage < 0.01f) continue;
-                double sampleO = aurora.getAuroraPresence(posXO, posZO, worldTime, celestialAngleO);
-                double sample = aurora.getAuroraPresence(posX, posZ, worldTime + 1, celestialAngle);
+                double sampleO = AURORA_PROVIDER.getAuroraPresence(posXO, posZO, worldTime, celestialAngleO);
+                double sample = AURORA_PROVIDER.getAuroraPresence(posX, posZ, worldTime + 1, celestialAngle);
                 if (sample * 0.3f * distanceSqPercentage < 0.01f) continue;
 
                 double atan = org.joml.Math.atan2(z, x);
@@ -343,18 +344,18 @@ public class RenderGlobal
                         double zOff = j * 8;
 
                         double aurX = (x + xOff) * scale;
-                        double aurY = (auroraY * scale  * scale) + aurora.getAuroraHeightOffset((posX + xOff), (posZ + zOff), time + 1);
+                        double aurY = (auroraY * scale  * scale) + AURORA_PROVIDER.getAuroraHeightOffset((posX + xOff), (posZ + zOff), time + 1);
                         double aurZ = (z + zOff) * scale;
 
-                        double aurYO = (auroraY * scale  * scale) + aurora.getAuroraHeightOffset((posX + xOff), (posZ + zOff), time);
+                        double aurYO = (auroraY * scale  * scale) + AURORA_PROVIDER.getAuroraHeightOffset((posX + xOff), (posZ + zOff), time);
 
-                        float r = aurora.getAuroraRedOffset((posX + xOff), (posZ + zOff), time + 1);
-                        float g = aurora.getAuroraGreenOffset((posX + xOff), (posZ + zOff), time + 1);
-                        float b = aurora.getAuroraBlueOffset((posX + xOff), (posZ + zOff), time + 1);
+                        float r = AURORA_PROVIDER.getAuroraRedOffset((posX + xOff), (posZ + zOff), time + 1);
+                        float g = AURORA_PROVIDER.getAuroraGreenOffset((posX + xOff), (posZ + zOff), time + 1);
+                        float b = AURORA_PROVIDER.getAuroraBlueOffset((posX + xOff), (posZ + zOff), time + 1);
 
-                        float ro = aurora.getAuroraRedOffset((posXO + xOff), (posZO + zOff), time);
-                        float go = aurora.getAuroraGreenOffset((posXO + xOff), (posZO + zOff), time);
-                        float bo = aurora.getAuroraBlueOffset((posXO + xOff), (posZO + zOff), time);
+                        float ro = AURORA_PROVIDER.getAuroraRedOffset((posXO + xOff), (posZO + zOff), time);
+                        float go = AURORA_PROVIDER.getAuroraGreenOffset((posXO + xOff), (posZO + zOff), time);
+                        float bo = AURORA_PROVIDER.getAuroraBlueOffset((posXO + xOff), (posZO + zOff), time);
 
                         renderAuroraBeam(this.tessellatorAurora,
                             aurX, aurY, aurZ,
@@ -1140,7 +1141,7 @@ public class RenderGlobal
                 this.toAdd[i] = null;
                 break;
             }
-            if (chunkx.rebuild(false)) {
+            if (chunkx.rebuild(GameSettings.KEY_LOAD_CHUNKS_QUICKLY.isPressed())) {
                 chunkx.setDirty(false);
                 this.dirtyChunks.remove(chunkx);
             }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index babac5c11..07f27b380 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -120,6 +120,9 @@ public final class BlockModelDispatcher
     public void reload() {
         BlockModelMojangData.Cache.resetCache();
         this.dispatches.clear();
+
+        addDispatch(new BlockModelEmpty<>(Blocks.AIR));
+
         addDispatch(new BlockModelGeneric<>(Blocks.STONE, loadDataModel("minecraft:block/stone")));
         addDispatch(new BlockModelGeneric<>(Blocks.BASALT, loadDataModel("minecraft:block/basalt")));
         addDispatch(new BlockModelGeneric<>(Blocks.LIMESTONE, loadDataModel("minecraft:block/limestone")));
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLayer.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLayer.java
index 6bdc97a76..92c4b7d8b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLayer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLayer.java
@@ -4,7 +4,12 @@ import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicLayerBase;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.useless.dragonfly.models.block.StaticBlockModel;
 
 public class BlockModelGenericLayer<T extends BlockLogic> extends BlockModelGeneric<T> {
@@ -21,4 +26,20 @@ public class BlockModelGenericLayer<T extends BlockLogic> extends BlockModelGene
     public @NotNull StaticBlockModel getModelFromData(int data) {
         return this.models[(data & BlockLogicLayerBase.MASK_HEIGHT) % this.models.length];
     }
+
+    private final @NotNull TilePos queryPos = new TilePos();
+    @Override
+    public boolean cullSide(@NotNull WorldSource worldSource, @NotNull TilePosc blockPos, @Nullable Direction direction) {
+        if (direction != null) {
+            TilePos shifted = blockPos.add(direction, this.queryPos);
+            if (worldSource.getBlockType(shifted) == this.block) {
+                int dataOther = worldSource.getBlockData(shifted);
+                int dataSelf = worldSource.getBlockData(blockPos);
+                return dataSelf <= dataOther || worldSource.isBlockOpaqueCube(shifted);
+            } else {
+                return worldSource.isBlockOpaqueCube(shifted);
+            }
+        }
+        return false;
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererPainting.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererPainting.java
index 97d384fdf..d1f86242e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererPainting.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererPainting.java
@@ -10,6 +10,7 @@ import net.minecraft.core.entity.EntityPainting;
 import net.minecraft.core.enums.ArtType;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 import org.joml.Math;
 
@@ -19,7 +20,6 @@ public class EntityRendererPainting extends EntityRenderer<EntityPainting> {
     private static final IconCoordinate paintingBack = TextureRegistry.getTexture("minecraft:art/backing");
 
     public EntityRendererPainting() {
-        this.rand = new Random();
     }
 
     private void renderArt(TessellatorGeneral tessellator, EntityPainting entity, int sizeX, int sizeY, IconCoordinate iconCoordinate) {
@@ -32,13 +32,13 @@ public class EntityRendererPainting extends EntityRenderer<EntityPainting> {
         final int tilesX = sizeX / 16;
         final int tilesY = sizeY / 16;
 
+        tessellator.startDrawingQuads();
         for (int x = 0; x < tilesX; x++) {
             for (int y = 0; y < tilesY; y++) {
                 final float maxX = negCenterX + (float) ((x + 1) * 16);
                 final float minX = negCenterX + (float) (x * 16);
                 final float maxY = negCenterY + (float) ((y + 1) * 16);
                 final float minY = negCenterY + (float) (y * 16);
-                setupPaintingBrightness(entity, (maxX + minX) / 2.0F, (maxY + minY) / 2.0F);
                 final double frontMinU = iconCoordinate.getSubIconU((tilesX - x) / (sizeX / 16f));
                 final double frontMaxU = iconCoordinate.getSubIconU((tilesX - x - 1) / (sizeX / 16f));
                 final double frontMinV = iconCoordinate.getSubIconV((tilesY - y) / (sizeY / 16f));
@@ -47,7 +47,8 @@ public class EntityRendererPainting extends EntityRenderer<EntityPainting> {
                 final double backMaxU = paintingBack.getIconUMax();
                 final double backMinV = paintingBack.getIconVMin();
                 final double backMaxV = paintingBack.getIconVMax();
-                tessellator.startDrawingQuads();
+
+                tessellator.setLightmapCoord1i(getPaintingLightIndex(entity, (maxX + minX) / 2.0F, (maxY + minY) / 2.0F));
                 tessellator.setNormal(0.0F, 0.0F, -1F);
                 tessellator.addVertexWithUV(maxX, minY, minZ, frontMaxU, frontMinV);
                 tessellator.addVertexWithUV(minX, minY, minZ, frontMinU, frontMinV);
@@ -91,14 +92,14 @@ public class EntityRendererPainting extends EntityRenderer<EntityPainting> {
                     tessellator.addVertexWithUV(minX, minY, minZ, backMaxU, backMaxV);
                     tessellator.addVertexWithUV(minX, minY, maxZ, subU, backMaxV);
                 }
-                tessellator.draw();
             }
 
         }
-
+        tessellator.draw();
     }
+    private final @NotNull TilePos queryPos = new TilePos();
 
-    private void setupPaintingBrightness(EntityPainting entity, float centerX, float centerY) {
+    private int getPaintingLightIndex(@NotNull EntityPainting entity, float centerX, float centerY) {
         int worldX = MathHelper.floor(entity.x);
         int worldY = MathHelper.floor(entity.y + (double) (centerY / 16F));
         int worldZ = MathHelper.floor(entity.z);
@@ -114,13 +115,12 @@ public class EntityRendererPainting extends EntityRenderer<EntityPainting> {
         if (entity.direction == 3) {
             worldZ = MathHelper.floor(entity.z + (double) (centerX / 16F));
         }
-        GLRenderer.setLightmapCoord1i(entity.world.getLightmapCoord(worldX, worldY, worldZ, entity.world.getBlockLightValue(worldX, worldY, worldZ)));
-        GLRenderer.setColor3f(1f, 1f, 1f);
+        this.queryPos.set(worldX, worldY, worldZ);
+        return entity.world.getSavedLightIndex(this.queryPos);
     }
 
     @Override
     public void render(@NotNull TessellatorGeneral tessellator, @NotNull EntityPainting entity, double x, double y, double z, float yaw, float partialTick) {
-        this.rand.setSeed(187L);
         GLRenderer.pushFrame();
         GLRenderer.modelM4f().translate((float) x, (float) y, (float) z);
         GLRenderer.modelM4f().rotateY(Math.toRadians(yaw));
@@ -147,6 +147,9 @@ public class EntityRendererPainting extends EntityRenderer<EntityPainting> {
         float maxZ = 0.5f;
         int width = sizeX / 16;
         int height = sizeY / 16;
+
+        TessellatorGeneral tessellator = GLRenderer.getTessellator();
+        tessellator.startDrawingQuads();
         for (int x = 0; x < width; ++x) {
             for (int y = 0; y < height; ++y) {
                 float maxX = negCenterX + (float) ((x + 1) * 16);
@@ -167,8 +170,6 @@ public class EntityRendererPainting extends EntityRenderer<EntityPainting> {
                     minY -= 0.1f;
                 }
 
-                this.setupPaintingBrightness(entity, (maxX + minX) / 2.0f, (maxY + minY) / 2.0f);
-
                 int index = getIndex(width - x - 1, height - y - 1, width, height);
 
                 float u = (index % 4) / 4f;
@@ -179,8 +180,7 @@ public class EntityRendererPainting extends EntityRenderer<EntityPainting> {
                 float minV = v + 0.25f;
                 float maxV = v;
 
-                TessellatorGeneral tessellator = GLRenderer.getTessellator();
-                tessellator.startDrawingQuads();
+                tessellator.setLightmapCoord1i(getPaintingLightIndex(entity, (maxX + minX) / 2.0f, (maxY + minY) / 2.0f));
                 tessellator.setNormal(0.0f, 0.0f, 1.0f);
                 tessellator.addVertexWithUV(maxX, minY, minZ, maxU, minV);
                 tessellator.addVertexWithUV(minX, minY, minZ, minU, minV);
@@ -238,12 +238,13 @@ public class EntityRendererPainting extends EntityRenderer<EntityPainting> {
                     tessellator.addVertexWithUV(maxX, minY, minZ, minU, maxV);
                     tessellator.addVertexWithUV(maxX, maxY, minZ, minU, minV);
                 }
-
-                tessellator.draw();
             }
         }
+        tessellator.draw();
     }
 
+
+
     private int getIndex(int x, int y, int width, int height) {
         if (width == 1 && height == 1) { // 1x1
             return 15;
@@ -292,6 +293,4 @@ public class EntityRendererPainting extends EntityRenderer<EntityPainting> {
         }
         return 5;
     }
-
-    private final Random rand;
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/Font.java b/game/client/src/main/java/net/minecraft/client/render/font/Font.java
index 316a08e2a..d6d153e44 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/Font.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/Font.java
@@ -24,5 +24,5 @@ public interface Font {
 
     int fontHeight();
 
-    double renderChar(TessellatorFont tessellator, char c, double x, double y, double z, boolean italics);
+    double renderChar(TessellatorFont tessellator, char c, double x, double y, double z);
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontDefault.java b/game/client/src/main/java/net/minecraft/client/render/font/FontDefault.java
index 52c3b02cb..33aae017e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/FontDefault.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontDefault.java
@@ -3,27 +3,27 @@ package net.minecraft.client.render.font;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.tessellator.TessellatorFont;
 import net.minecraft.client.render.texture.Texture;
-import net.minecraft.core.util.helper.ChatAllowedCharacters;
 import org.jetbrains.annotations.NotNull;
 
 public class FontDefault extends FontFile {
+
     public FontDefault(@NotNull final String key) {
         super(key, "/assets/minecraft/textures/gui/font/default/font_%02X.png", "/assets/minecraft/textures/gui/font/default/glyph_sizes.bin");
     }
 
     @Override
     public boolean canRenderChar(final char c) {
-        return c == ' ' || (!DEFAULT_BLACKLIST.contains(c) && ChatAllowedCharacters.ALLOWED_CHARACTERS.indexOf(c) >= 0 && textureForChar(c) != 0);
+        return c == ' ' || (ALLOWED_CHARACTER_INDICES[c] >= 0 && textureForChar(c) != 0);
 //        return false;
     }
 
     @Override
     public int textureForChar(final char c) {
-        final int fontIndex = ChatAllowedCharacters.ALLOWED_CHARACTERS.indexOf(c);
+        final int fontIndex = ALLOWED_CHARACTER_INDICES[c];
         if (fontIndex < 0) return 0;
         final int index = fontIndex / GLYPHS_PER_TEXTURE;
         if (this.texHandleCache[index] != TEXTURE_UNASSIGNED) return this.texHandleCache[index];
-        final Texture texture = Minecraft.getMinecraft().textureManager.loadTextureNoDefault(String.format(this.textureFormat, index));
+        final Texture texture = Minecraft.getMinecraft().textureManager.loadTextureNoDefault(this.textureLocationTable[index]);
         if (texture == null) {
             this.texHandleCache[index] = 0;
             return 0;
@@ -35,7 +35,7 @@ public class FontDefault extends FontFile {
     @Override
     public double charWidthDouble(final char c) {
         if (c == ' ') return 4;
-        final int fontIndex = ChatAllowedCharacters.ALLOWED_CHARACTERS.indexOf(c);
+        final int fontIndex = ALLOWED_CHARACTER_INDICES[c];
         if (fontIndex < 0) return 0;
 
         final int upper = this.charWidth[fontIndex] >> 4;
@@ -47,13 +47,11 @@ public class FontDefault extends FontFile {
     }
 
     @Override
-    public double renderChar(final TessellatorFont tessellator, final char c, final double x, final double y, final double z, final boolean italics) {
+    public double renderChar(final TessellatorFont tessellator, final char c, final double x, final double y, final double z) {
         if (c == ' ') return 4;
-        final int fontIndex = ChatAllowedCharacters.ALLOWED_CHARACTERS.indexOf(c);
+        final int fontIndex = ALLOWED_CHARACTER_INDICES[c];
         if (fontIndex < 0) return 0;
 
-        final int shift = italics ? ITALICS_SHIFT : 0;
-
         final int upper = this.charWidth[fontIndex] >> 4;
         final int lower = this.charWidth[fontIndex] & 0x0F;
         final int fUpper = upper;
@@ -62,13 +60,10 @@ public class FontDefault extends FontFile {
 
         final int u = (fontIndex % 16 * 16) + fUpper;
         final int v = (fontIndex & 0xff) / 16 * 16;
-        final int uWidth = fLower - fUpper;
-        final int vHeight = 16;
-
-        final double width = uWidth/2d;
-        final double height = vHeight/2d;
+        final int width = fLower - fUpper;
+        final int height = 16;
 
-        tessellator.addChar(x, y, width, height, shift, u, v, uWidth, vHeight);
+        tessellator.addChar(x, y, width, height, u, v);
 
         return (fLower - fUpper)/2d + 1;
     }
